Attribute VB_Name = "modRotatePicture"
'**********************************************
'* Module to print rotated picture on screen: *
'**********************************************

Option Explicit

Private Type POINTAPI

  X As Long
  Y As Long
  
End Type

Private Const PI As Double = 3.14159265358979

Private Declare Function CreatePolygonRgn Lib "GDI32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Private Declare Function DeleteObject Lib "GDI32" (ByVal hObject As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function PlgBlt Lib "GDI32" (ByVal hDCDest As Long, lpPoint As POINTAPI, ByVal hDCSrc As Long, ByVal nXSrc As Long, ByVal nYSrc As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hbmMask As Long, ByVal xMask As Long, ByVal yMask As Long) As Long

Public Sub PrintRotatedPicture(ByRef oFrameSrc As PictureBox, ByRef oShapeSrc As Shape, ByRef oFrameDst As Object, ByRef oPictureDst As PictureBox, Optional ByRef oImageSrc As Image)

  On Error Resume Next
  
  Dim iRotation  As Integer
  Dim sFillColor As String
  Dim lWidthSrc  As Long
  Dim lHeightSrc As Long
  Dim lWidthDst  As Long
  Dim lHeightDst As Long
  Dim hRgn       As Long
  Dim pt()       As POINTAPI
  Dim i          As Integer
  Dim TX         As Integer 'X-translation
  Dim TY         As Integer 'Y-translation
  
  iRotation = oPictureDst.Tag
  sFillColor = oFrameDst.Tag
  
  If oShapeSrc.Tag = "0.0" Then
  
    lWidthSrc = oFrameSrc.Width
    lHeightSrc = oFrameSrc.Height
    
  Else
  
    lWidthSrc = oFrameSrc.Width - 2 * oShapeSrc.BorderWidth * iTwX
    lHeightSrc = oFrameSrc.Height - 2 * oShapeSrc.BorderWidth * iTwY
    
  End If
  
  If (iRotation < 90) Or (iRotation < 270 And iRotation >= 180) Then
  
    If lWidthSrc > lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + lWidthSrc * Cos((iRotation Mod 90) * PI / 180) Then
    
      lWidthDst = lWidthSrc
      TX = RoundUp((lWidthSrc - (lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + lWidthSrc * Cos((iRotation Mod 90) * PI / 180))) / 2)
      
    Else
    
      lWidthDst = RoundUp(lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + lWidthSrc * Cos((iRotation Mod 90) * PI / 180))
      
    End If
    
    If lHeightSrc > lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + lWidthSrc * Sin((iRotation Mod 90) * PI / 180) Then
    
      lHeightDst = lHeightSrc
      TY = RoundUp((lHeightSrc - (lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + lWidthSrc * Sin((iRotation Mod 90) * PI / 180))) / 2)
      
    Else
    
      lHeightDst = RoundUp(lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + lWidthSrc * Sin((iRotation Mod 90) * PI / 180))
      
    End If
    
  Else
  
    If lWidthSrc > lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + lHeightSrc * Cos((iRotation Mod 90) * PI / 180) Then
    
      lWidthDst = lWidthSrc
      TX = RoundUp((lWidthSrc - (lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + lHeightSrc * Cos((iRotation Mod 90) * PI / 180))) / 2)
      
    Else
    
      lWidthDst = RoundUp(lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + lHeightSrc * Cos((iRotation Mod 90) * PI / 180))
      
    End If
    
    If lHeightSrc > lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + lHeightSrc * Sin((iRotation Mod 90) * PI / 180) Then
    
      lHeightDst = lHeightSrc
      TY = RoundUp((lHeightSrc - (lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + lHeightSrc * Sin((iRotation Mod 90) * PI / 180))) / 2)
      
    Else
    
      lHeightDst = RoundUp(lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + lHeightSrc * Sin((iRotation Mod 90) * PI / 180))
      
    End If
    
  End If
  
  oFrameDst.Visible = False
  iRotation = iRotation Mod 360
  If iRotation < 0 Then iRotation = iRotation + 360 '0 <= iRotation < 360
  
  'Resize the destination picture box:
  
  oPictureDst.AutoRedraw = True
  oPictureDst.AutoSize = False
  oPictureDst.Cls
  oPictureDst.Width = lWidthDst
  oPictureDst.Height = lHeightDst
  
  If oShapeSrc.Tag <> "0.0" And Not (oImageSrc Is Nothing) Then
  
    oPictureDst.BackColor = oShapeSrc.BorderColor
    
  Else
  
    oPictureDst.BackColor = oFrameSrc.BackColor
    
  End If
  
  'Rotate the picture box:
  
  If Not (oImageSrc Is Nothing) Then
  
    oPictureDst.PaintPicture oImageSrc.Picture, oPictureDst.ScaleLeft + (oPictureDst.ScaleWidth - lWidthSrc / Screen.TwipsPerPixelX) / 2 - 1, oPictureDst.ScaleTop + (oPictureDst.ScaleHeight - lHeightSrc / Screen.TwipsPerPixelY) / 2 - 1, RoundUp(lWidthSrc / Screen.TwipsPerPixelX) + 2, RoundUp(lHeightSrc / Screen.TwipsPerPixelY) + 2
    ReDim pt(2)
    pt(0).X = 0
    pt(0).Y = 0
    pt(1).X = oPictureDst.ScaleWidth
    pt(1).Y = 0
    pt(2).X = 0
    pt(2).Y = oPictureDst.ScaleHeight
    
    For i = 0 To 2
    
      pt(i) = RotateP(oPictureDst.ScaleWidth / 2, oPictureDst.ScaleHeight / 2, pt(i), -iRotation * PI / 180)
      
    Next
    
    PlgBlt oPictureDst.hDC, pt(0), oPictureDst.hDC, 0, 0, oPictureDst.ScaleWidth, oPictureDst.ScaleHeight, ByVal 0&, ByVal 0&, ByVal 0&
    oPictureDst.Refresh
    
  End If
  
  'Set up 4 (+ 1) points:
  
  ReDim pt(4)
  
  pt(0).X = 0 + TX / Screen.TwipsPerPixelX
  pt(1).Y = 0 + TY / Screen.TwipsPerPixelY
  
  If (iRotation >= 0 And iRotation < 90) Or (iRotation >= 180 And iRotation < 270) Then
  
    pt(0).Y = (lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
    pt(1).X = (lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
    pt(2).X = (lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
    pt(2).Y = (lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
    pt(3).X = (lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
    pt(3).Y = (lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
    
  ElseIf (iRotation >= 90 And iRotation < 180) Or (iRotation >= 270 And iRotation < 360) Then
  
    pt(0).Y = (lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
    pt(1).X = (lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
    pt(2).X = (lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
    pt(2).Y = (lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
    pt(3).X = (lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
    pt(3).Y = (lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
    
  End If
  
  pt(4).X = pt(0).X
  pt(4).Y = pt(0).Y
  
  'Create a region from the points:
  
  hRgn = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
  SetWindowRgn oPictureDst.hWnd, hRgn, True
  DeleteObject hRgn
  
  'Remove old border and set oFrameDst to oPictureDst:
  
  MoveObject oFrameDst, oFrameDst.Left + oPictureDst.Left, oFrameDst.Top + oPictureDst.Top, oPictureDst.Width, oPictureDst.Height
  MoveObject oPictureDst, 0, 0
  
  If Left(oFrameSrc.Tag, 1) = "P" Then 'Polygonal rotation
  
  ' X' = X * cos + Y * sin + O_TX
  ' Y' = Y * cos - X * sin + O_TY
  
    Dim iPoints As Integer
    Dim sPoints As String
    Dim Ix()    As Long
    Dim Iy()    As Long
    Dim lMaxIx  As Long
    Dim lMaxIy  As Long
    Dim O_TX    As Long
    Dim O_TY    As Long
    
    iPoints = CInt(mid(oFrameSrc.Tag, 2, InStr(oFrameSrc.Tag, ";") - 2))
    sPoints = mid(oFrameSrc.Tag, InStr(oFrameSrc.Tag, ";") + 1)
    ReDim Ix(iPoints - 1)
    ReDim Iy(iPoints - 1)
    
    For i = 0 To iPoints - 1
    
      Ix(i) = CLng(Left(sPoints, InStr(sPoints, ",") - 1))
      Iy(i) = CLng(mid(sPoints, InStr(sPoints, ",") + 1, InStr(sPoints, " ") - InStr(sPoints, ",") - 1))
      sPoints = mid(sPoints, InStr(sPoints, " ") + 1)
      
    Next i
    
    lMaxIx = MaxArr(Ix)
    lMaxIy = MaxArr(Iy)
    
    If (iRotation >= 0 And iRotation < 90) Then
    
      O_TX = pt(0).X
      O_TY = pt(0).Y
      
    ElseIf (iRotation >= 270 And iRotation < 360) Then
    
      O_TX = pt(1).X
      O_TY = pt(1).Y
      
    ElseIf (iRotation >= 180 And iRotation < 270) Then
    
      O_TX = pt(2).X
      O_TY = pt(2).Y
      
    ElseIf (iRotation >= 90 And iRotation < 180) Then
    
      O_TX = pt(3).X
      O_TY = pt(3).Y
      
    End If
    
    ReDim pt(iPoints - 1)
    
    For i = 0 To iPoints - 1
    
      pt(i).X = Ix(i) / lMaxIx * oFrameSrc.Width / iTwX * Cos(iRotation * PI / 180) + Iy(i) / lMaxIy * oFrameSrc.Height / iTwY * Sin(iRotation * PI / 180) + O_TX
      pt(i).Y = Iy(i) / lMaxIy * oFrameSrc.Height / iTwY * Cos(iRotation * PI / 180) - Ix(i) / lMaxIx * oFrameSrc.Width / iTwX * Sin(iRotation * PI / 180) + O_TY
      
    Next i
    
    hRgn = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
    SetWindowRgn oPictureDst.hWnd, hRgn, True
    DeleteObject hRgn
    ReDim Ix(0)
    ReDim Iy(0)
    
  End If
  
  'Set new border:
  
  If oShapeSrc.Tag = "0.0" Then
  
    If oImageSrc Is Nothing And sFillColor = vbNullString Then
    
      oPictureDst.DrawWidth = 2
      oPictureDst.Line (pt(0).X, pt(0).Y)-(pt(1).X, pt(1).Y), vbBlack
      oPictureDst.Line (pt(1).X, pt(1).Y)-(pt(2).X, pt(2).Y), vbBlack
      oPictureDst.Line (pt(2).X, pt(2).Y)-(pt(3).X, pt(3).Y), vbBlack
      oPictureDst.Line (pt(3).X, pt(3).Y)-(pt(0).X, pt(0).Y), vbBlack
      
    End If
    
  Else
  
    Dim iBorderHorizontalWidth As Integer
    Dim iBorderVerticalWidth   As Integer
    Dim iBorderWidth           As Integer
    
    If iRotation Mod 90 = 0 Then
    
      iBorderHorizontalWidth = oShapeSrc.BorderWidth
      iBorderVerticalWidth = oShapeSrc.BorderWidth
      
    Else
    
      iBorderHorizontalWidth = oShapeSrc.BorderWidth * 2 ^ 0.5 * Cos((45 - (iRotation Mod 90)) * PI / 180)
      iBorderVerticalWidth = oShapeSrc.BorderWidth * 2 ^ 0.5 * Sin((45 + (iRotation Mod 90)) * PI / 180)
      
    End If
    
    MoveObject oFrameDst, oFrameDst.Left - iBorderHorizontalWidth * Screen.TwipsPerPixelX, oFrameDst.Top - iBorderVerticalWidth * Screen.TwipsPerPixelY, oFrameDst.Width + 2 * iBorderHorizontalWidth * Screen.TwipsPerPixelX, oFrameDst.Height + 2 * iBorderVerticalWidth * Screen.TwipsPerPixelY
    MoveObject oPictureDst, iBorderHorizontalWidth * Screen.TwipsPerPixelX, iBorderVerticalWidth * Screen.TwipsPerPixelY
    iBorderWidth = oShapeSrc.BorderWidth
    oFrameDst.BackColor = oShapeSrc.BorderColor
    pt(0).X = pt(0).X + iBorderHorizontalWidth - iBorderWidth / 2 * Sin((iRotation Mod 90) * PI / 180) - iBorderWidth * Cos((iRotation Mod 90) * PI / 180) - iBorderWidth / 2 * Sin((iRotation Mod 90) * PI / 180)
    pt(0).Y = pt(0).Y + iBorderVerticalWidth - iBorderWidth / 2 * Cos((iRotation Mod 90) * PI / 180) + iBorderWidth * Sin((iRotation Mod 90) * PI / 180) - iBorderWidth / 2 * Cos((iRotation Mod 90) * PI / 180)
    pt(1).X = pt(1).X + iBorderHorizontalWidth + iBorderWidth / 2 * Cos((iRotation Mod 90) * PI / 180) - iBorderWidth * Sin((iRotation Mod 90) * PI / 180) + iBorderWidth / 2 * Cos((iRotation Mod 90) * PI / 180)
    pt(1).Y = pt(1).Y + iBorderVerticalWidth - iBorderWidth / 2 * Sin((iRotation Mod 90) * PI / 180) - iBorderWidth * Cos((iRotation Mod 90) * PI / 180) - iBorderWidth / 2 * Sin((iRotation Mod 90) * PI / 180)
    pt(2).X = pt(2).X + iBorderHorizontalWidth + iBorderWidth / 2 * Sin((iRotation Mod 90) * PI / 180) + iBorderWidth * Cos((iRotation Mod 90) * PI / 180) + iBorderWidth / 2 * Sin((iRotation Mod 90) * PI / 180)
    pt(2).Y = pt(2).Y + iBorderVerticalWidth + iBorderWidth / 2 * Cos((iRotation Mod 90) * PI / 180) - iBorderWidth * Sin((iRotation Mod 90) * PI / 180) + iBorderWidth / 2 * Cos((iRotation Mod 90) * PI / 180)
    pt(3).X = pt(3).X + iBorderHorizontalWidth - iBorderWidth / 2 * Cos((iRotation Mod 90) * PI / 180) + iBorderWidth * Sin((iRotation Mod 90) * PI / 180) - iBorderWidth / 2 * Cos((iRotation Mod 90) * PI / 180)
    pt(3).Y = pt(3).Y + iBorderVerticalWidth + iBorderWidth / 2 * Sin((iRotation Mod 90) * PI / 180) + iBorderWidth * Cos((iRotation Mod 90) * PI / 180) + iBorderWidth / 2 * Sin((iRotation Mod 90) * PI / 180)
    pt(4).X = pt(0).X
    pt(4).Y = pt(0).Y
    
  End If
  
  hRgn = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
  SetWindowRgn oFrameDst.hWnd, hRgn, True
  DeleteObject hRgn
  ReDim pt(0)
  oPictureDst.ZOrder 0
  oPictureDst.Visible = True
  oFrameDst.Visible = True
  
End Sub

Private Function RotateP(ByRef X As Long, ByRef Y As Long, ByRef Point As POINTAPI, Angle As Double) As POINTAPI

  On Error Resume Next
  
  Dim Tmp1 As Double
  Dim Tmp2 As Double
  
  Tmp1 = Point.X - X
  Tmp2 = Point.Y - Y
  Point.X = Tmp1 * Cos(Angle) - Tmp2 * Sin(Angle)
  Point.Y = Tmp1 * Sin(Angle) + Tmp2 * Cos(Angle)
  Point.X = Point.X + X
  Point.Y = Point.Y + Y
  RotateP = Point
  
End Function

Private Function RoundUp(ByVal Value As Double) As Long

  On Error Resume Next
  
  If CLng(Value) = Value Then
  
    RoundUp = Value
    
  Else
  
    RoundUp = CLng(Value) + 1
    
  End If
  
End Function
